# Agent Configuration: bito-cra.properties File

{% hint style="info" %}
**Note:** This file is only available for people who are using the [**self-hosted**](/ai-code-reviews-in-git/install-run-as-a-self-hosted-service.md) version of AI Code Review Agent.
{% endhint %}

The **bito-cra.properties** file offers a comprehensive range of options for configuring the [**AI Code Review Agent**](/ai-code-reviews-in-git/overview.md), enhancing its flexibility and adaptability to various workflow requirements.

## bito-cra.properties Available Options

<table><thead><tr><th width="232" align="center">Property Name</th><th>Supported Values</th><th width="141">Is Mandatory?</th><th>Description</th></tr></thead><tbody><tr><td align="center"><strong>mode</strong></td><td><ul><li>cli</li><li>server</li></ul></td><td>Yes</td><td>Whether to run the Docker container in CLI mode for a one-time code review or as a webhooks service to continuously monitor for code review requests.</td></tr><tr><td align="center"><strong>pr_url</strong></td><td>Pull request URL in GitLab, GitHub and Bitbucket</td><td>Yes, if the mode is CLI.</td><td><p>The pull request provides files with changes and the actual code modifications.<br><br>When the <code>mode</code> is set to <code>server</code>, the <code>pr_url</code> is received either through a webhook call or via a REST API call.</p><p> </p><p>This release only supports webhook calls; other REST API calls are not yet supported.</p></td></tr><tr><td align="center"><strong>code_feedback</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>Setting it to <code>True</code> activates general code review comments to identify functional issues. If set to <code>False</code>, general code review will not be conducted.</td></tr><tr><td align="center"><strong>bito_cli.bito.access_key</strong></td><td><p>A valid Bito Access Key generated through Bito's web UI.</p><p> </p><p><a href="https://docs.bito.ai/account-and-settings/access-key">Learn More</a></p></td><td>Yes</td><td>Bito Access Key is an alternative to standard email and OTP authentication.</td></tr><tr><td align="center"><strong>git.provider</strong></td><td><ul><li>GITLAB</li><li>GITHUB</li><li>BITBUCKET</li></ul></td><td>Yes, if the mode is CLI.</td><td>The name of git repository provider.</td></tr><tr><td align="center"><strong>git.access_token</strong></td><td>A valid Git access token provided by GITLAB or GITHUB or BITBUCKET</td><td>Yes</td><td>You can use a personal access token in place of a password when authenticating to GitHub/GitLab/BitBucket in the command line or with the API.</td></tr><tr><td align="center"><strong>git.domain</strong></td><td>A URL where Git is hosted.</td><td>No</td><td>It is used to enter the custom URL of self-hosted GitHub/GitLab Enterprise.</td></tr><tr><td align="center"><strong>static_analysis</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>Enable or disable static code analysis, which is used to uncover functional issues in the code.</td></tr><tr><td align="center"><strong>static_analysis_tool</strong></td><td><ul><li>fb_infer</li><li>astral_ruff</li><li>mypy</li></ul></td><td>No</td><td>Comma-separated list of static analysis tools to run (e.g., <code>fb_infer,astral_ruff,mypy</code>).</td></tr><tr><td align="center"><strong>linters_feedback</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>Enables feedback from linters like ESLint, golangci-lint, and Astral Ruff.</td></tr><tr><td align="center"><strong>secret_scanner_feedback</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>Enables detection of secrets in code. For example, passwords, API keys, sensitive information, etc.</td></tr><tr><td align="center"><strong>dependency_check</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>This feature is designed to identify security vulnerabilities in open-source dependency packages, specifically for JS/TS/Node.JS and GoLang. Without this input, reviews for security vulnerabilities will not be conducted.</td></tr><tr><td align="center"><strong>dependency_check.snyk_auth_token</strong></td><td>A valid authentication token for accessing Snyk's cloud-based security database.</td><td>No</td><td>If not provided, access to Snyk's cloud-based security database for checking security vulnerabilities in open-source dependency packages will not be available.</td></tr><tr><td align="center"><strong>code_context</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>Enables enhanced code context awareness.</td></tr><tr><td align="center"><strong>server_port</strong></td><td>A valid and available TCP port number.</td><td>No</td><td>This is applicable when the <code>mode</code> is set to <code>server</code>. If not specified, the default value is <code>10051</code>.</td></tr><tr><td align="center"><strong>review_comments</strong></td><td><ul><li>1</li><li>2</li></ul></td><td>No</td><td><p>Set the value to <code>1</code> to display the code review in a single post, or <code>2</code> to show code review as inline comments, placing suggestions directly beneath the corresponding lines in each file for clearer guidance on improvements.</p><p><br>The default value is <code>2</code>.</p></td></tr><tr><td align="center"><strong>review_scope</strong></td><td><ul><li>security</li><li>performance</li><li>scalability</li><li>codeorg</li><li>codeoptimize</li></ul></td><td>No</td><td>Specialized commands to perform detailed analyses on specific aspects of your code.<br><br>You can provide comma-separated values to perform multiple types of code analysis simultaneously.<br><br><a href="/pages/KxOFImXmAci9BWB3yvl5#review-scope"><strong>Learn more</strong></a></td></tr><tr><td align="center"><strong>include_source_branches</strong></td><td>Glob/regex pattern.</td><td>No</td><td>Comma-separated list of branch patterns (glob/regex) to allow as pull request sources.</td></tr><tr><td align="center"><strong>include_target_branches</strong></td><td>Glob/regex pattern.</td><td>No</td><td>Comma-separated list of branch patterns (glob/regex) to allow as pull request targets.</td></tr><tr><td align="center"><strong>exclude_files</strong></td><td>Glob/regex pattern.</td><td>No</td><td><p>A list of files/folders that the AI Code Review Agent will not review if they are present in the diff.</p><p></p><p>By default, these files are excluded: <code>*.xml</code>, <code>*.json</code>, <code>*.properties</code>, <code>.gitignore</code>, <code>*.yml</code>, <code>*.md</code><br><br><a href="/pages/V65Fu9QpT5A6ebHzBJkM"><strong>Learn more</strong></a></p></td></tr><tr><td align="center"><strong>exclude_draft_pr</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>A binary setting that enables/disables automated review of pull requests (PR) based on the draft status.<br><br>The default value is <code>True</code> which skips automated review of draft PR.<br><br><a href="/pages/V65Fu9QpT5A6ebHzBJkM"><strong>Learn more</strong></a></td></tr><tr><td align="center"><strong>cra_version</strong></td><td><ul><li>latest</li><li>Any specific version tag</li></ul></td><td>No</td><td>Sets the agent version to run (<code>latest</code> or a specific version tag).</td></tr><tr><td align="center"><strong>post_as_request_changes</strong></td><td><ul><li>True</li><li>False</li></ul></td><td>No</td><td>Posts feedback as 'Request changes' review comments. Depending on your organization's Git settings, you may need to resolve all comments before merging.</td></tr><tr><td align="center"><strong>support_email</strong></td><td>Email address</td><td>No</td><td>Contact email shown in error messages.</td></tr><tr><td align="center"><strong>suggestion_mode</strong></td><td><ul><li>essential</li><li>comprehensive</li></ul></td><td>No</td><td><p>Controls AI suggestion verbosity. Available options are <code>essential</code> and <code>comprehensive</code>.<br></p><p>In <strong>Essential</strong> mode, only critical issues are posted as inline comments, and other issues appear in the main review summary under "Additional issues".</p><p><br>In <strong>Comprehensive</strong> mode, Bito also includes minor suggestion and potential nitpicks as inline comments.</p></td></tr></tbody></table>

&#x20;

&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bito.ai/ai-code-reviews-in-git/install-run-as-a-self-hosted-service/agent-configuration-bito-cra.properties-file.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
